import type { AuthSetting, SubscriptionsSetting } from '@tarojs/taro';
import type { PromiseOptionalAction, PromiseParamsAction } from '../type';
export type Authorize = PromiseParamsAction<(scope: string, mini?: boolean) => void>;
export type Get = PromiseOptionalAction<boolean, Taro.getSetting.SuccessCallbackResult>;
export type Open = PromiseOptionalAction<boolean, Taro.openSetting.SuccessCallbackResult>;
export type WithMiniAndAppAuthSetting = AuthSetting & {
    mini: AuthSetting;
    app?: Taro.getAppAuthorizeSetting.Result;
};
declare function useAuthorize(withSubscriptions?: boolean, withAppAuthSetting?: boolean): {
    authSetting: WithMiniAndAppAuthSetting;
    subscriptionsSetting: SubscriptionsSetting | {};
    authorize: Authorize;
    get: Get;
    open: Open;
};
export default useAuthorize;
