var _excluded = ["errMsg"];
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
import { stopBluetoothDevicesDiscovery, startBluetoothDevicesDiscovery, openBluetoothAdapter, makeBluetoothPair, isBluetoothDevicePaired, getConnectedBluetoothDevices, getBluetoothDevices, getBluetoothAdapterState, closeBluetoothAdapter } from '@tarojs/taro';
import { useRef, useEffect, useState } from '@taro-hooks/core';
import { isBoolean, isString } from '@taro-hooks/shared';
import usePromise from '../usePromise';
function useBluetooth() {
  var adapter = useRef();
  var _useState = useState([]),
    devices = _useState[0],
    setDevices = _useState[1];
  var _useState2 = useState([]),
    connectedDevices = _useState2[0],
    setConnectedDevices = _useState2[1];
  var getState = usePromise(getBluetoothAdapterState);
  var getDevices = usePromise(getBluetoothDevices);
  var getConnected = usePromise(getConnectedBluetoothDevices);
  var openAdapter = usePromise(openBluetoothAdapter);
  var closeAdapter = usePromise(closeBluetoothAdapter);
  var toggleAdapter = function toggleAdapter(switchOrMode) {
    if (isBoolean(switchOrMode) && switchOrMode || isString(switchOrMode)) {
      return openAdapter({
        mode: isString(switchOrMode) ? switchOrMode : 'central'
      }).then(function (res) {
        Promise.all([getState(), getDevices(), getConnected()]).then(function (_ref) {
          var stateResult = _ref[0],
            devicesResult = _ref[1],
            connectResult = _ref[2];
          var errMsg = stateResult.errMsg,
            state = _objectWithoutPropertiesLoose(stateResult, _excluded);
          adapter.current = state;
          var devices = devicesResult.devices;
          setDevices(devices);
          var connected = connectResult.devices;
          setConnectedDevices(connected);
        });
        return res;
      });
    }
    return closeAdapter();
  };
  useEffect(function () {
    toggleAdapter(true);
    return function () {
      toggleAdapter(false);
    };
  }, []);
  var makePair = usePromise(makeBluetoothPair);
  var isPairedAsync = usePromise(isBluetoothDevicePaired);
  var isPaired = function isPaired(deviceId) {
    return isPairedAsync({
      deviceId: deviceId
    });
  };
  var startDiscovery = usePromise(startBluetoothDevicesDiscovery);
  var stopDiscovery = usePromise(stopBluetoothDevicesDiscovery);
  var toggleDiscovery = function toggleDiscovery(option) {
    return option ? startDiscovery(option) : stopDiscovery();
  };
  return [{
    devices: devices,
    connectedDevices: connectedDevices,
    adapter: adapter.current
  }, {
    toggleAdapter: toggleAdapter,
    getState: getState,
    getDevices: getDevices,
    getConnected: getConnected,
    makePair: makePair,
    isPaired: isPaired,
    toggleDiscovery: toggleDiscovery
  }];
}
export default useBluetooth;