import { generateGeneralFail } from '../utils/tool';
import { BANNAMESPACE } from '../constant';
export function prefixClsEvent(prefixCls, eventName) {
  return prefixCls != null && prefixCls.length ? prefixCls + "." + eventName : eventName;
}
export function isSafeEvent(eventName) {
  return BANNAMESPACE.every(function (ban) {
    return !eventName.startsWith(ban);
  });
}
export function generateCheck(eventName, handlers) {
  if (!eventName || !(handlers != null && handlers.length)) {
    generateGeneralFail('EVENT CHANEL', 'event chanel params error');
    return false;
  }
  if (!isSafeEvent(eventName)) {
    generateGeneralFail('EVENT CHANEL', eventName + " is not valid");
    return false;
  }
  return true;
}