function _extends() { return _extends = Object.assign ? Object.assign.bind() : function (n) { for (var e = 1; e < arguments.length; e++) { var t = arguments[e]; for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]); } return n; }, _extends.apply(null, arguments); }
import { previewImage, previewMedia as taroPreviewMedia, getImageInfo, chooseImage, chooseMessageFile, editImage } from '@tarojs/taro';
import { useState } from '@taro-hooks/core';
import usePromise from '../usePromise';
import { saveImageToPhotosAlbum, compressImage } from './utils/index';
var INIT = {
  tempFilePaths: [],
  tempFiles: []
};
function useImage(options) {
  var _useState = useState(INIT),
    fileInfo = _useState[0],
    setFileInfo = _useState[1];
  var chooseAsync = usePromise(chooseImage);
  var chooseMessageAsync = usePromise(chooseMessageFile);
  var choose = function choose(chooseOption, messageFile) {
    if (chooseOption === void 0) {
      chooseOption = {};
    }
    if (messageFile) {
      return chooseMessageAsync(_extends({
        count: 1
      }, chooseOption));
    }
    return chooseAsync(_extends({}, options != null ? options : {}, chooseOption)).then(function (res) {
      var tempFilePaths = res.tempFilePaths,
        tempFiles = res.tempFiles;
      setFileInfo({
        tempFilePaths: tempFilePaths,
        tempFiles: tempFiles
      });
      return res;
    });
  };
  var compressAsync = usePromise(compressImage);
  var compress = function compress(src, quality) {
    if (quality === void 0) {
      quality = 80;
    }
    return compressAsync({
      src: src,
      quality: quality
    });
  };
  var getAsync = usePromise(getImageInfo);
  var get = function get(src) {
    return getAsync({
      src: src
    });
  };
  var saveAsync = usePromise(saveImageToPhotosAlbum);
  var save = function save(filePath) {
    return saveAsync({
      filePath: filePath
    });
  };
  var preview = usePromise(previewImage);
  var previewMedia = usePromise(taroPreviewMedia);
  var editAsync = usePromise(editImage);
  var edit = function edit(src) {
    return editAsync({
      src: src
    });
  };
  return [fileInfo, {
    choose: choose,
    compress: compress,
    get: get,
    preview: preview,
    previewMedia: previewMedia,
    save: save,
    edit: edit
  }];
}
export default useImage;