import { getRecorderManager } from '@tarojs/taro';
import { useRef } from '@taro-hooks/core';
import usePromise from '../usePromise';
import { generateGeneralFail } from '../utils/tool';
function useRecord() {
  var recorderManager = useRef(getRecorderManager());
  var start = usePromise(recorderManager.current.start);
  var stop = function stop() {
    return new Promise(function (resolve, reject) {
      try {
        var callback = function callback(result) {
          resolve(result);
        };
        recorderManager.current.onStop(callback);
        recorderManager.current.stop();
      } catch (e) {
        var error = generateGeneralFail('stopRecord', e.errMsg || e.message);
        reject(error);
      }
    });
  };
  return [recorderManager.current, {
    start: start,
    stop: stop
  }];
}
export default useRecord;