import type { NodesRef, SelectorQuery } from '@tarojs/taro';
import type { PromiseParamsAction, PromiseAction } from '../type';
export type GetBoundingClientRect = PromiseParamsAction<(selector: string, all?: boolean) => void, NodesRef.BoundingClientRectCallbackResult>;
export type GetContext = PromiseAction<string, NodesRef.ContextCallbackResult>;
export type GetFields = PromiseParamsAction<(selector: string, fields: NodesRef.Fields) => void, TaroGeneral.IAnyObject>;
export type GetNode = PromiseAction<string, NodesRef.NodeCallbackResult>;
export type GetScrollOffset = PromiseAction<string, NodesRef.ScrollOffsetCallbackResult>;
declare function useSelectorQuery(): [
    SelectorQuery,
    {
        querySelector: SelectorQuery['select'];
        querySelectorAll: SelectorQuery['selectAll'];
        selectViewport: SelectorQuery['selectViewport'];
        in: SelectorQuery['in'];
        exec: SelectorQuery['exec'];
        getBoundingClientRect: GetBoundingClientRect;
        getContext: GetContext;
        getFields: GetFields;
        getNode: GetNode;
        getScrollOffset: GetScrollOffset;
    }
];
export default useSelectorQuery;
