import Taro from '@tarojs/taro';
import type { VideoContext } from '@tarojs/taro';
import type { ExcludeOption, PromiseOptionalAction, PromiseAction, WithUndefind } from '../type';
export type ChooseOption = ExcludeOption<Taro.chooseVideo.Option>;
export type Choose = PromiseOptionalAction<ChooseOption, Taro.chooseVideo.SuccessCallbackResult>;
export type ChooseMedia = PromiseOptionalAction<ExcludeOption<Taro.chooseMedia.Option>, Taro.chooseMedia.SuccessCallbackResult>;
export type Save = PromiseAction<string>;
export type Get = PromiseAction<string, Taro.getVideoInfo.SuccessCallbackResult>;
export type Open = PromiseAction<string, Taro.openVideoEditor.SuccessCallbackResult>;
export type Compress = PromiseAction<ExcludeOption<Taro.compressVideo.Option>, Taro.compressVideo.SuccessCallbackResult>;
export type Option = {
    component?: TaroGeneral.IAnyObject;
} & ChooseOption;
declare function useVideo(id: string, option?: Option): [
    WithUndefind<VideoContext>,
    {
        choose: Choose;
        chooseMedia: ChooseMedia;
        get: Get;
        open: Open;
        save: Save;
        compress: Compress;
    }
];
export default useVideo;
