"use strict";

var _excluded = ["context", "success", "fail", "complete", "mixWithOther", "obeyMuteSwitch"];
function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }
  if (!value || !value.then) {
    value = Promise.resolve(value);
  }
  return then ? value.then(then) : value;
}
function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }
  if (result && result.then) {
    return result.then(void 0, recover);
  }
  return result;
}
function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }
    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setInnerAudioOption = void 0;
// extends setInnerOption with some private fields
var taro_1 = require("@tarojs/taro");
var tool_1 = require("../utils/tool");
var setInnerAudioOption = _async(function (_ref) {
  var context = _ref.context,
    success = _ref.success,
    fail = _ref.fail,
    complete = _ref.complete,
    _ref$mixWithOther = _ref.mixWithOther,
    mixWithOther = _ref$mixWithOther === void 0 ? true : _ref$mixWithOther,
    _ref$obeyMuteSwitch = _ref.obeyMuteSwitch,
    obeyMuteSwitch = _ref$obeyMuteSwitch === void 0 ? true : _ref$obeyMuteSwitch,
    contextField = _objectWithoutPropertiesLoose(_ref, _excluded);
  return _catch(function () {
    return _await((0, taro_1.setInnerAudioOption)({
      mixWithOther: mixWithOther,
      obeyMuteSwitch: obeyMuteSwitch
    }), function () {
      if (context) {
        for (var field in contextField) {
          context[field] = contextField[field];
        }
      }
      var result = {
        errMsg: 'setInnerAudioOption: success'
      };
      success == null ? void 0 : success(result);
      complete == null ? void 0 : complete(result);
      return result;
    });
  }, function (e) {
    var error = (0, tool_1.generateGeneralFail)('setInnerAudioOption', e.errMsg || e.message);
    fail == null ? void 0 : fail(error);
    complete == null ? void 0 : complete(error);
    throw new Error(error.errMsg);
  });
});
exports.setInnerAudioOption = setInnerAudioOption;