"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var tslib_1 = require("tslib");
var taro_1 = require("@tarojs/taro");
var core_1 = require("@taro-hooks/core");
var shared_1 = require("@taro-hooks/shared");
var usePromise_1 = tslib_1.__importDefault(require("../usePromise"));
function useBrightness(keepon) {
  var _ref = (0, core_1.useState)(),
    brightness = _ref[0],
    changeBrightness = _ref[1];
  var getAsync = (0, usePromise_1["default"])(taro_1.getScreenBrightness);
  var setAsync = (0, usePromise_1["default"])(taro_1.setScreenBrightness);
  var getBrightness = function getBrightness() {
    return getAsync().then(function (res) {
      if ((0, shared_1.isNumber)(res == null ? void 0 : res.value)) {
        changeBrightness(res.value);
      }
      return res;
    });
  };
  var setBrightness = function setBrightness(value) {
    return setAsync({
      value: value
    });
  };
  (0, core_1.useEffect)(function () {
    getBrightness();
    if (keepon) {
      (0, taro_1.setKeepScreenOn)({
        keepScreenOn: keepon
      });
    }
  }, []);
  return [brightness, setBrightness];
}
exports["default"] = useBrightness;