"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.generateCheck = exports.isSafeEvent = exports.prefixClsEvent = void 0;
var tool_1 = require("../utils/tool");
var constant_1 = require("../constant");
function prefixClsEvent(prefixCls, eventName) {
  return prefixCls != null && prefixCls.length ? prefixCls + "." + eventName : eventName;
}
exports.prefixClsEvent = prefixClsEvent;
function isSafeEvent(eventName) {
  return constant_1.BANNAMESPACE.every(function (ban) {
    return !eventName.startsWith(ban);
  });
}
exports.isSafeEvent = isSafeEvent;
function generateCheck(eventName, handlers) {
  if (!eventName || !(handlers != null && handlers.length)) {
    (0, tool_1.generateGeneralFail)('EVENT CHANEL', 'event chanel params error');
    return false;
  }
  if (!isSafeEvent(eventName)) {
    (0, tool_1.generateGeneralFail)('EVENT CHANEL', eventName + " is not valid");
    return false;
  }
  return true;
}
exports.generateCheck = generateCheck;