"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var tslib_1 = require("tslib");
var core_1 = require("@taro-hooks/core");
var taro_1 = require("@tarojs/taro");
var usePromise_1 = tslib_1.__importDefault(require("../usePromise"));
function useKeyboard() {
  var _ref = (0, core_1.useState)(0),
    height = _ref[0],
    setHeight = _ref[1];
  (0, core_1.useEffect)(function () {
    var handle = function handle(e) {
      setHeight(e.height);
    };
    (0, taro_1.onKeyboardHeightChange)(handle);
    return function () {
      (0, taro_1.offKeyboardHeightChange)(handle);
    };
  });
  var handleClose = (0, usePromise_1["default"])(taro_1.hideKeyboard);
  var getSelectedRange = (0, usePromise_1["default"])(taro_1.getSelectedTextRange);
  return {
    height: height,
    close: handleClose,
    getRange: getSelectedRange
  };
}
exports["default"] = useKeyboard;