"use strict";

function _empty() {}
function _call(body, then, direct) {
  if (direct) {
    return then ? then(body()) : body();
  }
  try {
    var result = Promise.resolve(body());
    return then ? result.then(then) : result;
  } catch (e) {
    return Promise.reject(e);
  }
}
function _callIgnored(body, direct) {
  return _call(body, _empty, direct);
}
function _catch(body, recover) {
  try {
    var result = body();
  } catch (e) {
    return recover(e);
  }
  if (result && result.then) {
    return result.then(void 0, recover);
  }
  return result;
}
function _continueIgnored(value) {
  if (value && value.then) {
    return value.then(_empty);
  }
}
function _await(value, then, direct) {
  if (direct) {
    return then ? then(value) : value;
  }
  if (!value || !value.then) {
    value = Promise.resolve(value);
  }
  return then ? value.then(then) : value;
}
function _invoke(body, then) {
  var result = body();
  if (result && result.then) {
    return result.then(then);
  }
  return then(result);
}
function _async(f) {
  return function () {
    for (var args = [], i = 0; i < arguments.length; i++) {
      args[i] = arguments[i];
    }
    try {
      return Promise.resolve(f.apply(this, args));
    } catch (e) {
      return Promise.reject(e);
    }
  };
}
Object.defineProperty(exports, "__esModule", {
  value: true
});
var tslib_1 = require("tslib");
var taro_1 = require("@tarojs/taro");
var usePromise_1 = tslib_1.__importDefault(require("../usePromise"));
var tool_1 = require("../utils/tool");
function useLogin() {
  var check = (0, usePromise_1["default"])(taro_1.checkSession);
  var loginAsync = (0, usePromise_1["default"])(taro_1.login);
  var pluginLoginAsync = (0, usePromise_1["default"])(taro_1.pluginLogin);
  var login = _async(function (needCheck, plugin, timeout) {
    var checkResult = !needCheck;
    return _invoke(function () {
      if (!checkResult) {
        return _continueIgnored(_catch(function () {
          return _callIgnored(check);
        }, function () {
          checkResult = false;
        }));
      }
    }, function () {
      var _exit = false;
      return _invoke(function () {
        if (!checkResult) {
          var payload = timeout ? {
            timeout: timeout
          } : {};
          return _await(plugin ? pluginLoginAsync(payload) : loginAsync(payload), function (_await) {
            _exit = true;
            return _await;
          });
        }
      }, function (_result) {
        return _exit ? _result : (0, tool_1.generateGeneralFail)('login', 'code is valid, do not use fetch new one!');
      });
    });
  });
  return {
    check: check,
    login: login
  };
}
exports["default"] = useLogin;