"use strict";

var _excluded = ["errMsg"];
function _objectWithoutPropertiesLoose(r, e) { if (null == r) return {}; var t = {}; for (var n in r) if ({}.hasOwnProperty.call(r, n)) { if (-1 !== e.indexOf(n)) continue; t[n] = r[n]; } return t; }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterErrMsgField = exports.stringfiyUrl = exports.combineOptions = exports.generateGeneralFail = exports.isUndefined = exports.isPlainObject = exports.typeOf = exports.promiseNoop = exports.noop = exports.isProd = void 0;
var shared_1 = require("@taro-hooks/shared");
var querystring_1 = require("querystring");
// prod constants
exports.isProd = process.env.NODE_ENV === 'production';
var noop = function noop() {};
exports.noop = noop;
var promiseNoop = function promiseNoop() {
  return Promise.resolve();
};
exports.promiseNoop = promiseNoop;
var typeOf = function typeOf(target, type) {
  return [type].flat().some(function (v) {
    return Object.prototype.toString.call(target) === "[object " + v + "]";
  });
};
exports.typeOf = typeOf;
var isPlainObject = function isPlainObject(payload) {
  return !(payload && Object.entries(payload).length);
};
exports.isPlainObject = isPlainObject;
var isUndefined = function isUndefined(target) {
  return typeof target === 'undefined';
};
exports.isUndefined = isUndefined;
/**
 * general common error message resp
 * @param {T = string} method 调用方法
 * @param {string} message 自定义错误信息
 * @returns {TaroGeneral.CallbackResult} 错误信息
 */
function generateGeneralFail(method, message) {
  message = message || '调用失败';
  var errMsg = "[API " + method + "] " + message;
  if (!exports.isProd) (0, shared_1.logError)(errMsg);
  return {
    errMsg: errMsg
  };
}
exports.generateGeneralFail = generateGeneralFail;
/**
 * combine init and custom options
 * @param generalOption init options
 * @param option custom options
 * @returns options
 */
function combineOptions(generalOption, option) {
  if (generalOption === void 0) {
    generalOption = {};
  }
  if (option === void 0) {
    option = {};
  }
  return Object.assign({}, generalOption, option);
}
exports.combineOptions = combineOptions;
/**
 * make queryString URI
 * @param url origin URI
 * @param options unparse payload
 * @returns {string} URIWithQS
 */
function stringfiyUrl(url, options) {
  var stringfiyUrl = url;
  if (options && (0, shared_1.strictOf)(options, 'Object')) {
    var hasQuery = stringfiyUrl.includes('?');
    stringfiyUrl += (hasQuery ? '&' : '?') + (0, querystring_1.stringify)(options);
  }
  return stringfiyUrl;
}
exports.stringfiyUrl = stringfiyUrl;
/**
 * filter orgin successCallbackResult errMsg Fields
 * @param successResultArray
 * @returns WithoutErrMsgArray
 */
function filterErrMsgField(successResultArray) {
  return successResultArray.map(function (_ref) {
    var errMsg = _ref.errMsg,
      result = _objectWithoutPropertiesLoose(_ref, _excluded);
    return result;
  });
}
exports.filterErrMsgField = filterErrMsgField;